; display - for RLM

(define (lines-needed str)
  (inexact->exact
    (ceiling (/ (string-length str) 32))))

(define (fld-show f s)
  (frm-show f (not (eq? "" s)))
  (fld-set-text f s))

(define (stackdisp-update stack)
  (let*
    ((pos (- (car (scl-get-val 2002))))
     (s (drop stack pos))
     (v (length s)))
    (fld-show 2000 "")
    (fld-show 2016 "")
    (fld-show 2017 "")
    (fld-show 2018 "")
    (fld-show 2011 "")
    (fld-show 2012 "")
    (fld-show 2013 "")
    (fld-show 2014 "")
    (fld-show 2010 "")
    (let
      ((os0 (if (> v 0) (object->string (car s)) ""))
       (os1 (if (> v 1) (object->string (cadr s)) ""))
       (os2 (if (> v 2) (object->string (caddr s)) ""))
       (os3 (if (> v 3) (object->string (cadddr s)) ""))
       (os4 (if (> v 4) (object->string (caddddr s)) "")))
      (case  (lines-needed os0)
	((0) #f)
	((1)
	 (fld-show 2010 os4)
	 (fld-show 2011 os3)
	 (fld-show 2012 os2)
	 (fld-show 2013 os1)
	 (fld-show 2014 os0))
	((2)
	 (fld-show 2010 os3)
	 (fld-show 2011 os2)
	 (fld-show 2012 os1)
	 (fld-show 2018 os0))
	((3)
	 (fld-show 2010 os2)
	 (fld-show 2011 os1)
	 (fld-show 2017 os0))
	((4)
	 (fld-show 2010 os1)
	 (fld-show 2016 os0))
	(else (fld-show 2000 os0))))))

(define (vardisp-update kmenu)
  (let ((v (length kmenu)))
    (ctl-set-label 2020
      (if (> v 0) (caar kmenu) ""))
    (ctl-set-label 2021
      (if (> v 1) (caadr kmenu) ""))
    (ctl-set-label 2022
      (if (> v 2) (caaddr kmenu) ""))
    (ctl-set-label 2023
      (if (> v 3) (caadddr kmenu) ""))
    (ctl-set-label 2024
      (if (> v 4) (caaddddr kmenu) ""))
    (ctl-set-label 2025
      (if (> v 5) (caadddddr kmenu) ""))))
