; a-list - for RLM

(define (a-store alist key val)
  (let ((e (assoc key alist)))
    (if e 
      (begin
        (set-cdr! e val)
        alist)
      (cons (cons key val) alist))))

(define (assoc-pred key alist)
  (if (null? alist)
    #f
    (if (null? (cdr alist))
      #f
      (if (equal? key (caadr alist))
        alist
        (assoc-pred key (cdr alist))))))

(define (a-purge alist key)
  (if (null? alist) 
    alist
    (if (equal? key (caar alist))
      (cdr alist)
      (let ((p (assoc-pred key alist)))
        (if p (set-cdr! p (cddr  p)))
        alist)))

